#pragma once

#include "Buffer.h"
#include <winsock2.h>

#define NETWORK_SEND_DIRECT	0

class CNetworkSend
{
public:
	CNetworkSend(DWORD dwSendBlockSize=0);
	~CNetworkSend(void);

	BOOL Open(char *address,WORD port);
	void Close();
	BOOL IsOpen();
	DWORD GetOpenTick();
	BOOL Send(void *lpData,DWORD dwDataSize,DWORD *lpdwWritten=NULL);
	unsigned __int64 GetSendTotalSize()
	{
		return m_ui64SendSizeTotal;
	}
	void GetIpAddress(BYTE *pbyAddr)
	{
		if(IsOpen())
		{
			pbyAddr[0]=m_addr.sin_addr.S_un.S_un_b.s_b1;
			pbyAddr[1]=m_addr.sin_addr.S_un.S_un_b.s_b2;
			pbyAddr[2]=m_addr.sin_addr.S_un.S_un_b.s_b3;
			pbyAddr[3]=m_addr.sin_addr.S_un.S_un_b.s_b4;
		} else {
			pbyAddr[0]=pbyAddr[1]=pbyAddr[2]=pbyAddr[3]=0;
		}
	}

protected:
	CBufferMT *m_pBuf; // IjbΉ
	SOCKET	m_sock;
	struct sockaddr_in m_addr;
	DWORD m_dwBlockSendSize;
	DWORD m_dwSendStartTick;
	unsigned __int64 m_ui64SendSizeTotal;

	BOOL _SendBlock(DWORD dwSendSize,DWORD *lpdwWritten);
};
